#!/usr/bin/python
# -*- coding: utf-8 -*-
# Copyright (c) 2006 UbuntuChina <http://www.ubuntu.org.cn>
# License: GPLv2
# Author: oneleaf <oneleaf AT gmail.com>
# Version: 0.1

import SimpleHTTPServer
import BaseHTTPServer,SocketServer
import httplib
import BitTorrent.download, BitTorrent.bencode
from threading import Event,Thread
import os
import tempfile
from distutils import dir_util       
from time import sleep

class RequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
    def do_GET(self):
        getfile(self,self.path)

btsite="bt.ubuntu.org.cn"
stoptime=36000
timeout=10

def getfile(self,url):
    print "call btserver begin..."
    conn = httplib.HTTPConnection(btsite+':8080')
    conn.request("GET",url)
    response = conn.getresponse()
    print "call btserver end."
    if (response.msg.gettype()=="text/html") or (response.msg.getmaintype()=="image"):   
        self.send_response(response.status,response.reason)
        self.send_header("content-type",response.msg.getmaintype())       
        self.end_headers()   
        self.wfile.write(response.read())
    else:     
        if response.status<>200 :
            self.send_response(response.status,response.reason)
            self.send_header("content-type","text/plain")
            self.end_headers()
            self.wfile.write(response.read())                       
        else:
            file='/tmp/archive'+url
            if response.getheader('Content-Disposition').endswith('.torrent'):
                self.send_header("content-type","text/plain")
                self.send_header("Content-length",response.getheader("Source-length"))               
                dir_util.mkpath(os.path.split(file)[0])
                btfile=file+".torrent"
                tfile=open(file+".torrent",'w+b')
                tfile.write(response.read())
                tfile.flush()
                tfile.close()
                if downloadfilefrombt(self,btfile,file)==1:
                    self.send_response(200)
                    self.end_headers()
                    self.wfile.write(open(file).read())
                else:
                    self.send_response(403,'download error!')
                    self.end_headers()
                    self.wfile.write('download error!')           
            else:
                self.send_response(200)
                self.send_header("content-type","text/plain")
                self.send_header("Content-length",response.getheader("Content-length"))
                self.end_headers()
                self.wfile.write(response.read())
                         
def downloadfilefrombt(self, btfile, file):
    print "download",file[file.rfind('/')+1:],"begin..."
    for i in range(6):
        btdownload=Btdownload(btfile, file)
        btdownload.btdownload()
        mtimeout=timeout
        while btdownload.hasdownload==0:
            if mtimeout<1 and btdownload.fractionDone==0.0:
                btdownload.join()
                print "download",file[file.rfind('/')+1:],"timeout,restarting..."
                break
            mtimeout=mtimeout-1
            self.send_header("fractionDone",btdownload.fractionDone)
            sleep(1)
        if btdownload.hasdownload==1:
            print "download",file[file.rfind('/')+1:],"end."           
            return 1     
    print "download",file[file.rfind('/')+1:],"error!" 
    return 0
       
btfiles={}
class Btdownload:
    def __init__(self, btfile, file):
        self.btfile = btfile
        self.file = file
        self.event = Event()
        self.hasdownload=0
        self.fractionDone=0.0
        self.thread=None
     
    def choose(self,default, size, saveas, dir): return saveas
    def param(self, params):pass
    def display(self,dict):
        if dict.has_key('fractionDone'):
            self.fractionDone=float(int(dict['fractionDone']*1000))/10         
            if dict.get('fractionDone') <> 1.0:
                print self.file[self.file.rfind('/')+1:],
                print "fractionDone",str(self.fractionDone)+"%",
                if dict.has_key('activity'): print dict['activity'],
                if dict.has_key('downRate'):print 'downrate', int(dict['downRate'])/1000,"K",
                print
        if btfiles.has_key(self.btfile):
            if btfiles[self.btfile]['stoptime']>0:
                btfiles[self.btfile]['stoptime']=btfiles[self.btfile]['stoptime']-1
            else:
                self.join()
                del btfiles[self.btfile]   
                os.remove(self.btfile)
                os.remove(self.file)               
         
    def error(self,message): print message
    def finished(self): self.hasdownload=1
    def newpath(self, path): self.file = path       
    def btdownload(self):
        if self.btfile in btfiles.keys():
            btfiles[self.btfile]['stoptime']=stoptime
        else:
            btfiles[self.btfile]={'stoptime':stoptime,'object':self}
        args=(['--url','file://'+self.btfile,'--saveas', self.file], self.choose, self.display, self.finished, self.error, self.event, 100, self.newpath, self.param)
        self.thread=Thread(None,BitTorrent.download.download,"BitTorrent.download.download", args)
        self.thread.start()
    def join(self):
        if self.event:
            self.event.set()
            self.event = None
        self.timeout=-1
         
class myWebServer(SocketServer.ThreadingMixIn,BaseHTTPServer.HTTPServer): pass
         
if __name__ == "__main__":
    try:
        server = myWebServer(('', 8080), RequestHandler)
        server.serve_forever()
    finally:
        for btfile in btfiles.keys():
            btfiles[btfile]['object'].join()
            os.remove(btfiles[btfile]['object'].btfile)
            os.remove(btfiles[btfile]['object'].file) 
